/*---------------------------------------------------*/
/* PINGU! 27/10/2014 P.R.
/* ho dovuto cambiare la dichiarazione del font display
nel file libraries/Adafruit_PCD8544/Adafruit_PCD8544.cpp
const extern uint8_t PROGMEM font[];        // cod attuale
extern uint8_t PROGMEM font[];              // riga obsoleta

e nel file libraries/Adafruit_GFX/glcdfont.c
const uint8_t font[] PROGMEM = {            // cod attuale
static unsigned char  font[] PROGMEM = {    // obsoleta
/*---------------------------------------------------*/

#include <EEPROM.h>
#include <Wire.h>
#include "RealTimeClockDS1307.h"
#include "DHT22.h"
#include "HX711.h"
#include <Stepper.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
#include <Bridge.h>
#include <YunServer.h>
#include <YunClient.h>

#define TASK_1sec 1
#define TASK_10sec 10
#define TASK_30sec 30
#define TASK_30min 1800
#define secondi_delay 50


Adafruit_PCD8544 display = Adafruit_PCD8544(13, 4, 5, 6, 12);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2

#define LOGO16_GLCD_HEIGHT 16
#define LOGO16_GLCD_WIDTH  16

char* giorno[] = {
  "Lun"	        	// 0
  , "Mar"			// 1
  , "Mer"			// 2
  , "Gio"			// 3
  , "Ven"			// 4
  , "Sab"			// 5
  , "Dom"			// 6
};

//int a = 0;
byte PLAYE=7;
byte relay_water_pin = A5;
byte button_pin = A4;

HX711 scale_croc(A1, A0);
// HX711.DOUT	- pin #A1
// HX711.PD_SCK	- pin #A0
HX711 scale_water(A2, A3);
// HX711.DOUT	- pin #A2
// HX711.PD_SCK	- pin #A3

//byte manual_water = 0;

byte year_stamp;
byte month_stamp;
byte day_stamp;
int hours_stamp;
int minutes_stamp;
int seconds_stamp;
byte dayofweek_stamp;

unsigned long previousTime = 0;
unsigned long currentTime 	= 0;
unsigned long deltaTime 	= 0;           // Tempo tra 2 letture millis() x calc. t.passato
unsigned long frameCounter = 0;           // main loop executive frame counter

long qta_crocchette = 10;
long qta_acqua = 50;
long actual_acqua; 
byte pagina = 8;
 
unsigned long Secondigiorno; 
unsigned long start_secondi[8][2];

Stepper myStepper(2048,8,10,9,11);

YunServer server;

/*---------------------------------------------------------------------*/
// SETUP SETUP SETUP SETUP SETUP SETUP SETUP SETUP SETUP SETUP SETUP   
/*---------------------------------------------------------------------*/
void setup () {
  
  pinMode(relay_water_pin, OUTPUT); 
  digitalWrite(relay_water_pin, HIGH);    
    
  myStepper.setSpeed(8);
 
  Wire.begin();                     // Start our wire and real time clock
  Serial.begin(57600);
   
   // in arduino yun seems that fuse is set to clear eeprom when upload a sketch. 
   // So you need to change fuse or write eeprom each time you upload a sketch.
   // i*10 		= ore timer
	// i*10+1 	= minuti timer
	// i*10+2	= qta crocchette
	
   EEPROM.write(0,8);
   EEPROM.write(1,30);
   EEPROM.write(2,10);
   EEPROM.write(10,9);
   EEPROM.write(11,35);
   EEPROM.write(12,10);
   EEPROM.write(20,10);
   EEPROM.write(21,40);
   EEPROM.write(22,10);
   EEPROM.write(30,11);
   EEPROM.write(31,45);
   EEPROM.write(32,15);
   EEPROM.write(40,12);
   EEPROM.write(41,50);
   EEPROM.write(42,20);
   EEPROM.write(50,13);
   EEPROM.write(51,55);
   EEPROM.write(52,20);
   EEPROM.write(60,15);
   EEPROM.write(61,0);
   EEPROM.write(62,5);
   EEPROM.write(70,16);
   EEPROM.write(71,5);
   EEPROM.write(72,10);
     
   scale_croc.set_scale(429.f); //calibrazione bilancia croccantini 429
   scale_croc.tare();	
  
   scale_water.set_scale(390.f); //calibrazione bilancia acqua  390
   scale_water.tare();	
   
   display.begin();
   display.setContrast(60);		// you can change the contrast around to adapt the display for the best viewing!
   display.display(); 				// show splashscreen
   delay(1500);
   display.clearDisplay();
   
   timers();							// inizializzo array dei timer e dei pesi 
   
  Bridge.begin();
  server.listenOnLocalhost();
  server.begin();
}  // fine setup

/*---------------------------------------------------------------------*/
// LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP LOOP 
/*---------------------------------------------------------------------*/
void loop () {

  currentTime = millis();
  deltaTime = currentTime - previousTime;
  
  processSerialCommand();  					// setting orologio via monitor seriale
  delay(1);                					// necessario dopo aver processato la seriale
  
  int valore = analogRead(button_pin);		// controllo per il feed manuale
  if(valore >= 470 && valore <=490 )
  {
     myStepper.step(-3072);
     //Serial.println(F("acc_man"));
  }


  YunClient client = server.accept();
  if (client) {
  process(client);
  client.stop();
  }
  delay(1);
  
  /*    
  if (digitalRead(manual_water_button_pin)==LOW) {
    accendo_acqua();
    manual_water = 1;    
  } 
  if (digitalRead(manual_water_button_pin)==HIGH && digitalRead(relay_water_pin)==LOW && manual_water ==1) {
    spengo_acqua();
    manual_water = 0;
  } 
  */  
     
  // ===================================================================
  // 1 sec task loop
  // ===================================================================
  if (deltaTime >= 1000) {
    frameCounter++;
    process1secTask();

    // =================================================================
    // 10sec task loop
    // =================================================================
    if (frameCounter % TASK_10sec == 0) {  
      process10secTask();
    }
    
    // =================================================================
    // 30sec task loop
    // =================================================================
    if (frameCounter % TASK_30sec == 0) {  
      process30secTask();
    }
    
    // =================================================================
    // 30 min task
    // =================================================================
    if (frameCounter % TASK_30min == 0) {  //  30 min task
      process30minTask();
    }

    previousTime = currentTime;
  }
  if (frameCounter >= 1800) {
    frameCounter = 0;
  }
}  // fine loop




// ===================================================================
// 1 sec task loop definition
// ===================================================================
void process1secTask() {
 
  RTC.readClock();
  year_stamp = RTC.getYear();
  month_stamp = RTC.getMonth();
  day_stamp = RTC.getDay();
  hours_stamp = RTC.getHours();
  minutes_stamp = RTC.getMinutes();
  seconds_stamp = RTC.getSeconds(); 
  dayofweek_stamp = RTC.getDayOfWeek();
 
  /*---------------------------------------------------------*/
  /* controllo se devo accendere crocchette                  */
  /* Ho usato int e fare la moltiplic in due passaggi        */
  /* x evitare overflow                                      */
  /*---------------------------------------------------------*/
  Secondigiorno = hours_stamp; 
  Secondigiorno = Secondigiorno*3600 + seconds_stamp + (minutes_stamp*60); 
  byte i;
  for (i=0;i<=7;i++)  {
    if (start_secondi[i][0] == Secondigiorno)  		// ok - è ora di mangiare - accendo crocchette
    {
      qta_crocchette = start_secondi[i][1]; 
      digitalWrite(PLAYE, HIGH);							// chiamo spritz!
      delay(1);
      digitalWrite(PLAYE, LOW);
      //Serial.println();     
      //Serial.print(F("acc"));
             
      byte j = 0;
      while (j<10)											// faccio un po' di giri con il motore stepper
      {															// e controllo per fermarlo alla qta di crocchette giusta	        
        myStepper.step(-3072); // 2 giri
        long x = int(scale_croc.get_units(10));
        //Serial.print(F("bilan croc "));
        //Serial.println(x);
           
        if( x >= qta_crocchette)
        {  
         // Serial.println(F("Spen3"));
          //digitalWrite(led_pin, LOW);
          j = 10;
        }    
      j = j++;
      }
       
     
    }
  }  //fine for
  
  /*---------------------------------------------------------*/
  /* Set dell'orologio, dei timers e della qta crocchette    */
  /*---------------------------------------------------------*/
  
  int valore = analogRead(button_pin);
  //Serial.println();     
  //Serial.print(valore);
  if(valore >= 95 && valore <=112 )		// scroll display 
  {
    pagina = pagina+1;
    if (pagina >=9)
      pagina = 0;  
    //Serial.print(F("pag."));
    //Serial.print(pagina);   
  }
  
  byte nnn;
  byte hh;
  if(valore >= 65 && valore <=78 )		// SET ORE orologio o timer
  {
    if (pagina == 8)  						// aumento le ore dell'orologio
    {
       hh = RTC.getHours();
       if (hh >= 23) 
         hh = 0;
       else
         hh = hh+1;
         
       RTC.setHours(hh);
       RTC.setClock();
    }
    else              						// aumento le ore del timer x la pagina attuale
    {     
      nnn = 10*pagina;
      hh = EEPROM.read(nnn);
      if (hh >= 23) 
         hh = 0;
       else
         hh = hh+1;
      
      //Serial.println();
      //Serial.print("xxx.");
      //Serial.print(pagina);
      //Serial.print("-");
      //Serial.print(nnn);
      //Serial.print("-");
      //Serial.println(hh);
      EEPROM.write(nnn,hh);
      timers(); 
     }
  }  
  
  if(valore >= 188 && valore <=200 )	// SET MINUTI orologio o dei timers
  {
    if (pagina == 8)  						// aumento i minuti dell'orologio
    {
      hh = RTC.getMinutes();
      if (hh >= 59) 
        hh = 0;
      else
        hh = hh+1;
      RTC.setMinutes(hh);
      RTC.setClock();
    }
    else              						// aumento i minuti del timer x la pagina attuale
    {     
      nnn = 10*pagina+1;
      hh = EEPROM.read(nnn);
      if (hh >= 59) 
         hh = 0;
       else
         hh = hh+1;
      
     // Serial.println();
     // Serial.print(F("xxx."));
     // Serial.print(pagina);
     // Serial.print(F(" "));
     // Serial.print(nnn);
    //  Serial.print(F(" "));
    //  Serial.println(hh);
    //  Serial.print(F(" "));
      EEPROM.write(nnn,hh);
      
      timers(); 								// aggiorno la eeprom con i nuovi dati
     }
  }  
     
  if(valore >= 295 && valore <=315 )	// SET qta crocchette. Aumento qtà di 5 grammi alla volta. Max 50 gr. 
  {     
    nnn = 10*pagina+2;
    byte gr;
    if (pagina  <=7)
    {
      gr = EEPROM.read(nnn);
      gr = gr+5;
      if(gr == 55)
        gr = 5;
      EEPROM.write(nnn,gr);
    }   
    timers();									// aggiorno la eeprom con i nuovi dati 
  }
  
  chg_pagina(pagina);						// mostro orologio in base alla pagina in cui mitrovo
  
  /*---------------------------------------------------------*/
  /* controllo il livello dell'acqua                         */
  /*---------------------------------------------------------*/
   actual_acqua = int(scale_water.get_units(10)); 
  if( actual_acqua < qta_acqua && digitalRead(relay_water_pin)==HIGH)
      accendo_acqua();
  if( actual_acqua >= qta_acqua && digitalRead(relay_water_pin)==LOW)
      spengo_acqua();     
   
 /* Serial.print(F("liv acq "));
  Serial.println(x);
   
  Serial.print(giorno[dayofweek_stamp-1]);
  Serial.print(F(" "));
  Serial.print(day_stamp);
  Serial.print(F("/"));
  Serial.print(month_stamp);
  Serial.print(F("/"));
  Serial.print(year_stamp);
  Serial.print(F("    "));
  Serial.print(hours_stamp);
  Serial.print(F(":"));
  Serial.print(minutes_stamp);
  Serial.print(F(":"));
  Serial.print(seconds_stamp);
  Serial.print(F(" now: "));  
  Serial.println(Secondigiorno);
  */
     
} // FINE PROCESSO 1 SEC

/*---------------------------------------------------------*/
void process10secTask() {
}  // fine processo 10 sec

/*---------------------------------------------------------*/
void process30secTask() {
}  // fine processo 30 sec

/*---------------------------------------------------------*/
void process30minTask() {
}  // fine processo 30 min


// ---------------------------------------------------------
// verso acqua - functions declaration                     
// ---------------------------------------------------------
void  accendo_acqua() {
//  Serial.println();     
// Serial.print(F("accen acq"));
  digitalWrite(relay_water_pin, LOW); // eccito il relè collegato al pin2
}  

void  spengo_acqua() {
 // Serial.println();     
 // Serial.print(F("spen acq"));
  digitalWrite(relay_water_pin, HIGH); // spengo il relè collegato al pin2
} 

/*--------------------------------------------------------------------------*/
/* Carico i tempi di accensione e grammi da versare in array                */
/*--------------------------------------------------------------------------*/
/*          pos |  0 | 1  | 2  |
            ____________________   
 eeprom:   |    |  H |  m | gr.|      valori di esempio
           |  0 |  8 | 30 | 10 |      8*3600 = 28800 + 30*60 = 1800 --> 30600
           | 10 |  9 | 35 | 11 |      9*3600 = 32400 + 35*60 = 2100 --> 34500
           | 20 | 10 | 40 | 12 |     10*3600 = 36000 + 40*60 = 2400 --> 38400
           | 30 | 11 | 45 | 13 |
           | .. | .. | .. | .. |
           | 70 | 23 | 30 | 10 |     23*3600 = 82800 + 30*60 = 1800 --> 84600
 
 -----------------------------------
 array:    | n. |  sec    | gr.|     (trasformato in secondi)
           | 0  | 30600   | 10 |
           | 1  | 34500   | 11 |
           | 2  | 38400   | 15 |
           | .  | .....   | .. | 
           | 7  | 84600   | 10 |
*/
/*--------------------------------------------------------------------------*/


// --------------------------------------------------------------------------
// Aggiorno l'array dei timers con i nuovi tempi convertiti in secondi      
// --------------------------------------------------------------------------
void timers() {

  byte i = 0;
  
  for (i=0;i<=7;i++)
  {
    start_secondi[i][0] = EEPROM.read(i*10);
    delay(10);
    start_secondi[i][0] = start_secondi[i][0]*3600+EEPROM.read(i*10+1)*60;
    delay(10);
    start_secondi[i][1]=EEPROM.read(i*10+2);
  //  Serial.print(start_secondi[i][0]);
  //  Serial.print(F(" - "));
   // Serial.print(start_secondi[i][1]);
  //  Serial.println(F("--")); 
  }
}


// ===================================================================
// Aggiornamento del display 
// ===================================================================
  
void chg_pagina(int num)
{  
  if(num == 8)								// Display dell'orologio
  {     
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(BLACK);
    display.setCursor(0,0);
    RTC.readClock();
    year_stamp = RTC.getYear();
    month_stamp = RTC.getMonth();
    day_stamp = RTC.getDay();
    hours_stamp = RTC.getHours();
    minutes_stamp = RTC.getMinutes();
    seconds_stamp = RTC.getSeconds(); 
    dayofweek_stamp = RTC.getDayOfWeek();
    display.print(giorno[dayofweek_stamp-1]);
    display.print(F(" "));
    display.print(day_stamp);
    display.print(F("/"));
    display.print(month_stamp);
    display.print(F("/"));
    display.println(year_stamp);     
    display.setCursor(14,17);
    display.setTextSize(2);
    display.print(hours_stamp);
    
    if (seconds_stamp % 2 == 0)
      display.print(F(":"));
    else
      display.print(F(" "));
    
    display.println(minutes_stamp);
    display.display(); 
  }
  else										// allora mostro timer[num]
  {
    display.clearDisplay();
    display.setTextSize(1);
    display.setTextColor(BLACK);
    display.setCursor(0,0);
    int hh = EEPROM.read(num*10);      
    int ii = EEPROM.read(num*10+1);       
    int gr = EEPROM.read(num*10+2);
    display.print(F("Timer "));
    display.print(num+1);
    display.setCursor(10,17);
    display.setTextSize(2);
    display.print(hh);
    display.print(F(":"));
    display.println(ii); 
    display.setTextSize(1);    
    display.print(F("Gr. "));
    display.print(gr);
    display.display(); 
  }   
} 	 // fine aggiornamento del display

// ---------------------------------------------------------
// processo i comandi inseriti dalla seriale
// ---------------------------------------------------------
void processSerialCommand() {
  if(!Serial.available()) { 
    return; 
  }
  char command = Serial.read();
  int in;
  switch(command)
  {
  case 'h':
    in=SerialReadPosInt();
    RTC.setHours(in);
    RTC.setClock();
    Serial.print(F("Set hours to "));
    Serial.println(in);
    break;
/*  case 'i':
    in=SerialReadPosInt();
    RTC.setMinutes(in);
    RTC.setClock();
    Serial.print(F("Set minutes to "));
    Serial.println(in);
    break;
  case 's':
    in=SerialReadPosInt();
    RTC.setSeconds(in);
    RTC.setClock();
    Serial.print(F("Set seconds to "));
    Serial.println(in);
    break;
  case 'y':
    in=SerialReadPosInt();
    RTC.setYear(in);
    RTC.setClock();
    Serial.print(F("Set year to "));
    Serial.println(in);
    break;
  case 'm':
    in=SerialReadPosInt();
    RTC.setMonth(in);
    RTC.setClock();
    Serial.print(F("Set month to "));
    Serial.println(in);
    break;
  case 'd':
    in=SerialReadPosInt();
    RTC.setDay(in);
    RTC.setClock();
    Serial.print(F("Set date to "));
    Serial.println(in);
    break;
  case 'z':
    RTC.start();
    Serial.println(F("Clk osc start"));
    break;
  case 'Z':
    RTC.stop();
    Serial.println(F("Clk osc stop"));
    break;
  case 't':
    if(RTC.is12hour()) {
      RTC.switchTo24h();
      Serial.println(F("Sw 24h"));
    } 
    else {
      RTC.switchTo12h();
      Serial.println(F("Sw12h"));
    }
    RTC.setClock();
    break;
  case 'a':
    if(RTC.is12hour()) {
      RTC.setAM();
      RTC.setClock();
      Serial.println(F("Set AM."));
    } 
    else {
      Serial.println(F("Set only 24h"));
    }
    break;
  case 'P':
    if(RTC.is12hour()) {
      RTC.setPM();
      RTC.setClock();
      Serial.println(F("Set PM"));
    } 
    else {
      Serial.println(F("Set h only 24h mode."));
    }
    break;
  case 'q':
    RTC.sqwEnable(RTC.SQW_1Hz);
    Serial.println(F("Sq wave1Hz"));
    break;
  case 'Q':
    RTC.sqwDisable(0);
    Serial.println(F("Sqwave disabled"));
    break;    
  case 'x':
    in=SerialReadPosInt();
    RTC.setDayOfWeek(in);
    RTC.setClock();
    Serial.print(F("Setday week "));
    Serial.println(in);
    break;    
 
   */
  default:
    Serial.println(F("Comandi ammessi:"));
    Serial.println(F(" h## - set Hours        d## - set Date"));
    Serial.println(F(" i## - set mInutes      m## - set Month"));
    Serial.println(F(" s## - set Seconds      y## - set Year"));
    Serial.println(F(" t   - 12/24 hours      x   - set n-day 1-7"));
    Serial.println(F(" a   - set AM           p   - set PM"));
    Serial.println(F(" q   - set sqw on       Q   - set sqw off"));
    Serial.println();
    Serial.println(F(" z   - start clock      Z   - stop clock"));
   
  }//switch on command
}

// ---------------------------------------------------------
// leggo i char numerici in entrata sulla serial
// ---------------------------------------------------------
int SerialReadPosInt() {
  int i = 0;
  boolean done=false;
  while(Serial.available() && !done)
  {
    char c = Serial.read();
    if (c >= '0' && c <='9')
      i = i * 10 + (c-'0');
    else 
      done = true;
  }
  return i;
}

void process(YunClient client) {
String command = client.readStringUntil('/');

if (command == "status") {
  statoCommand(client);
  }
}

void statoCommand(YunClient client) {
  long a = int(scale_croc.get_units(10));
  // gr crocchette nella ciotola
  client.print(F("status"));
  client.print(F("#"));
  client.print("pc");
  client.print(F("="));
  client.print(a);
  
  a = actual_acqua;      
  client.print(F("#"));
  client.print("pa");
  client.print(F("="));
  client.print(a);
 
  byte b = analogRead(A4); 
  client.print(F("#"));
  client.print("vc");
  client.print(F("="));
  client.print(b);
  
  b = analogRead(A5);  
  client.print(F("#"));
  client.print("va");
  client.print(F("="));
  client.print(b);
  
  int i;
  byte timer;
  for (i=0;i<=7;i++)  {
  byte kk = 10*i;
  timer = EEPROM.read(kk);
  client.print(F("#"));
  client.print("t");
  client.print(i);
  client.print(F("="));
  if (timer <10) 
  client.print(0);
  client.print(timer);
  client.print(F(":"));
  timer = EEPROM.read(kk+1);
  if (timer <10) 
  client.print(0);
  client.print(timer);
  
  //devo inserire un valore fittizio, altrimenti non viene visualizzato l'ultimo timer 
  //perché gli si aggancia il ritorno a capo di risp 200
  client.print(F("#"));
  client.print("zz");
  client.print(F("="));
  client.print(0);
  
  }
  
  client.println("");  //importante ok200
  
}


